using System;

interface IStorable
{
	void Read();
	void Write(object obj);
	int Status { get; set; }

}

// ο ̽
interface ICompressible
{
	void Compress();
	void Decompress();
}

// ̽ Ȯ
interface ILoggedCompressible : ICompressible
{
	void LogSavedBytes();
}

// ̽ 
interface IStorableCompressible : IStorable, ILoggedCompressible
{
	void LogOriginalSize();
}

//  ٸ ̽
interface IEncryptable
{
	void Encrypt();
	void Decrypt();
}

public class Document : IStorableCompressible, IEncryptable
{
	// Document 
	public Document(string s) 
	{
		Console.WriteLine("Creating document with: {0}", s);
        
	}
    
	// IStorable 
	public void Read()
	{
		Console.WriteLine(
			"Implementing the Read Method for IStorable");
	}

	public void Write(object o)
	{
		Console.WriteLine(
		"Implementing the Write Method for IStorable");  
	}

	public int Status
	{
		get
		{
			return status;
		}

		set
		{
			status = value;
		}
	}
    
	// ICompressible 
	public void Compress() 
	{ 
		Console.WriteLine("Implementing Compress"); 
	}
    
	public void Decompress()
	{ 
		Console.WriteLine("Implementing Decompress"); 
	}
    
	// ILoggedCompressible 
	public void LogSavedBytes()
	{
		Console.WriteLine("Implementing LogSavedBytes");
	}
    
	// IStorableCompressible  
	public void LogOriginalSize()
	{
		Console.WriteLine("Implementing LogOriginalSize");
	}

	// IEncryptable 
	public void Encrypt()
	{
		Console.WriteLine("Implementing Encrypt");

	}

	public void Decrypt()
	{
		Console.WriteLine("Implementing Decrypt");

	}

	// IStorable Status Ƽ ͸ Ѵ.
	private int status = 0;
}

public class Tester
{

	static void Main()
	{
		// Document ü Ѵ.
		Document doc = new Document("Test Document");

		// پ ̽ ĳƮѴ.
		IStorable isDoc = doc as IStorable;
		if (isDoc != null)
		{
			isDoc.Read();
		}
		else
			Console.WriteLine("IStorable not supported");
        
		ICompressible icDoc = doc as ICompressible;
		if (icDoc != null)
		{
			icDoc.Compress();
		}
		else
			Console.WriteLine("Compressible not supported");

		ILoggedCompressible ilcDoc = doc as ILoggedCompressible;
		if (ilcDoc != null)
		{
			ilcDoc.LogSavedBytes();
			ilcDoc.Compress();
			// ilcDoc.Read();
		}
		else
			Console.WriteLine("LoggedCompressible not supported");

		IStorableCompressible isc = doc as IStorableCompressible;
		if (isc != null)
		{
			isc.LogOriginalSize();  // IStorableCompressible
			isc.LogSavedBytes();    // ILoggedCompressible
			isc.Compress();         // ICompressible
			isc.Read();             // IStorable

		}
		else
		{
			Console.WriteLine("StorableCompressible not supported");
		}

		IEncryptable ie = doc as IEncryptable;
		if (ie != null)
		{
			ie.Encrypt();
		}
		else
			Console.WriteLine("Encryptable not supported");
	}
}

